---
title: 'Square tilemaps implementation: Static maps'
slug: 'Games/Techniques/Tilemaps/Square_tilemaps_implementation:_Static_maps'
tags:
  - Canvas
  - Games
  - JavaScript
  - Static
  - atlas
  - spritesheet
  - tilemap
  - tilemaps
  - tiles
---
<div>{{GamesSidebar}}</div>

<p class="summary">This article covers how to implement static square tilemaps using the <a href="/en-US/docs/Web/API/Canvas_API">Canvas API</a>.</p>

<div class="note">
<p><strong>Note</strong>: When writing this article, we assumed previous reader knowledge of canvas basics such as how get a 2D canvas context, load images, etc., which is all explained in the <a href="/en-US/docs/Web/API/Canvas_API/Tutorial">Canvas API tutorial</a>, as well as the basic information included in our <a href="/en-US/docs/Games/Techniques/Tilemaps">Tilemaps</a> introduction article.</p>
</div>

<h2 id="The_tile_atlas">The tile atlas</h2>

<p>A tilemap might use one or several atlases — or spritesheets — that contain all of the tile images. This is the atlas we will be using as an example, which features five different tiles:</p>

<p><img alt="Tiles packaged in an atlas" src="https://mdn.mozillademos.org/files/11641/tiles.png" style="height: 64px; width: 320px;"></p>

<p>To draw a tile from the atlas into the canvas we make use of the {{domxref("CanvasRenderingContext2D.drawImage","drawImage()")}} method in a canvas 2D context. We need to supply the atlas image, the coordinates and dimensions of the tile inside the atlas, and the target coordinates and size (a different tile size in here would scale the tile.)</p>

<p>So, for instance, to draw the tree tile, which is the third in the atlas, at the screen coordinates <code>(128, 320)</code>, we would call <code>drawImage()</code> with these values:</p>

<pre class="brush: js">context.drawImage(atlasImage, 192, 0, 64, 64, 128, 320, 64, 64);</pre>

<p>In order to support atlases with multiple rows and columns, you would need to know how many rows and columns there are to be able to compute the source <code>x</code> and <code>y</code>.</p>

<h2 id="The_tilemap_data_structure">The tilemap data structure</h2>

<p>To store that map data, we can use a plain object or a custom class. For the sake of simplicity, in the example code a plain object has been used. It contains the basic map properties:</p>

<ul>
 <li><code>cols</code>: The width of the map, in columns.</li>
 <li><code>rows</code>: The height of the map, in rows.</li>
 <li><code>tsize</code>: The tile size, in pixels.</li>
 <li><code>tiles</code>: A 1-dimensional array containing the visual grid.</li>
 <li><code>getTile()</code>: A helper method that gets the tile index in a certain position.</li>
</ul>

<p><code>tiles</code> contains the actual visual map data. We are representing the tiles with indices, assigned to the tiles dependant on their position in the atlas (e.g. <code>0</code> for the left-most tile.) However, we must account for <strong>empty tiles</strong>, since they are crucial for implementing layers — empty tiles are usually assigned a negative index value, <code>0</code>, or a null value. In these examples, empty tiles will be represented by index <code>0</code>, so we will shift the indices of the atlases by one (and thus the first tile of the atlas will be assigned index <code>1</code>, the second index <code>2</code>, etc.)</p>

<p>The <code>getTile()</code> helper method returns the tile contained at the specified column and row. If <code>tiles</code> were a 2D matrix, then the returned value would just be <code>tiles[column][row]</code>. However, it's usually more common to represent the grid with a 1-dimensional array. In this case, we need to map the column and row to an array index:</p>

<pre class="brush: js">var index = row * map.cols + column;</pre>

<p>Wrapping up, an example of a tilemap object could look like the following. This features an 8 x 8 map with tiles 64 x 64 pixels in size:</p>

<pre class="brush: js">var map = {
  cols: 8,
  rows: 8,
  tsize: 64,
  tiles: [
    1, 3, 3, 3, 1, 1, 3, 1,
    1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 2, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 2, 1, 1, 1, 1,
    1, 1, 1, 1, 2, 1, 1, 1,
    1, 1, 1, 1, 2, 1, 1, 1,
    1, 1, 1, 0, 0, 1, 1, 1
  ],
  getTile: function(col, row) {
    return this.tiles[row * map.cols + col]
  }
};</pre>

<h2 id="Rendering_the_map">Rendering the map</h2>

<p>We can render the map by iterating over its columns and rows. This snippets assumes the following definitions:</p>

<ul>
 <li><code>context</code>: A 2D canvas context.</li>
 <li><code>tileAtlas</code>: An image object containing the tile atlas.</li>
 <li><code>map</code>: The tilemap object discussed above.</li>
</ul>

<pre class="brush: js">for (var c = 0; c &lt; map.cols; c++) {
  for (var r = 0; r &lt; map.rows; r++) {
    var tile = map.getTile(c, r);
    if (tile !== 0) { // 0 =&gt; empty tile
      context.drawImage(
        tileAtlas, // image
        (tile - 1) * map.tsize, // source x
        0, // source y
        map.tsize, // source width
        map.tsize, // source height
        c * map.tsize, // target x
        r * map.tsize, // target y
        map.tsize, // target width
        map.tsize // target height
      );
    }
  }
}</pre>

<h2 id="Demo">Demo</h2>

<p>Our static tilemap implementation demo pulls the above code together to show what an implementation of this map looks like. You can see a <a href="https://mozdevs.github.io/gamedev-js-tiles/square/no-scroll.html">live demo</a> and grab the <a href="https://github.com/mozdevs/gamedev-js-tiles">full source code</a>.</p>

<p><a href="https://mozdevs.github.io/gamedev-js-tiles/square/no-scroll.html"><img alt="" src="https://mdn.mozillademos.org/files/11659/no-scroll.png" style="display: block; height: 256px; margin: 0px auto; width: 256px;"></a></p>
